package com.octacoregames.flappyunicorn;

import com.octacoregames.flappyunicorn.R;
import android.os.Bundle;
import android.app.AlertDialog;
import android.content.DialogInterface;

import com.google.android.gms.games.Games;
import com.google.example.games.basegameutils.BaseGameActivity;

public class MainActivity extends BaseGameActivity {
	final String LEADERBOARD_ID = "CgkI27DwvosTEAIQAA";
	final int REQUEST_LEADERBOARD = 0;

	public static MainActivity instance = null;
	public static MainActivity getInstance() {
		return instance;
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		instance = this;
	}

 	@Override
    public void onDestroy(){
    	SoundManager.getInstance().stopBGM();
    	SoundManager.getInstance().stop(true);
    	super.onDestroy();
    	System.exit(0);
    }
 	
 	@Override
 	public void onBackPressed() {
 	    new AlertDialog.Builder(this)
 	    .setIcon(R.drawable.ic_launcher)
        .setTitle("Warning")
        .setMessage("Are you sure you want to exit "+getText(R.string.app_name)+"?")
        .setPositiveButton("Yes", new DialogInterface.OnClickListener()
    {
        @Override
        public void onClick(DialogInterface dialog, int which) {
            finish();
        }

    })
    .setNegativeButton("No", null)
    .show();
 		
 	}

	@Override
	public void onSignInFailed() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onSignInSucceeded() {
		// TODO Auto-generated method stub
		
	}

	public void submitScore(int score) {
		if(isSignedIn()) {
		  Games.Leaderboards.submitScore(getApiClient(), LEADERBOARD_ID, score);
		  //signOut();
		} else {
	        // start the asynchronous sign in flow
	        beginUserInitiatedSignIn();			
		}
	}
	
	public void showLeaderboard() {
		if(isSignedIn()) {
		  startActivityForResult(Games.Leaderboards.getLeaderboardIntent(getApiClient(), LEADERBOARD_ID), REQUEST_LEADERBOARD);
		} else {
	        // start the asynchronous sign in flow
	        beginUserInitiatedSignIn();			
		}		
	}
	
}

