package com.octacoregames.flappyunicorn;

import com.octacoregames.flappyunicorn.R;
import com.octacoregames.flappyunicorn.R.raw;

import android.media.MediaPlayer;

//v1.0 SoundManager by Octacore
public class SoundManager {
	public static final byte BGM_MAIN			= 0;
	public static final byte MAX_BGM			= BGM_MAIN + 1;
	public static final byte SFX_DIE			= 0;
	public static final byte SFX_HIT			= SFX_DIE + 1;
	public static final byte SFX_POINT			= SFX_HIT + 1;
	public static final byte SFX_SWOOSHING		= SFX_POINT + 1;
	public static final byte SFX_WING			= SFX_SWOOSHING + 1;
	public static final byte MAX_SFX			= SFX_WING + 1;
	public static final String[] bgmFilename = {"humming"};
	public static final String[] sfxFilename = {"boo", "meow", "tada", "tic", "yahoo"};
	public static final int[] bgmId = {
		0,//R.raw.humming,
	};
	public static final int[] sfxId = {
		R.raw.sfx_die,
		R.raw.sfx_hit,
		R.raw.sfx_point,
		R.raw.sfx_swooshing,
		R.raw.sfx_wing
	};
	
	private int toPlay = -1;
	private MediaPlayer bgm = null;
	private MediaPlayer sound[] = null;
	public static SoundManager instance = null;

	public static boolean musicEnabled = true;
	public static boolean soundEnabled = true;//false;

	public boolean supportsMID = false;
	public boolean supportsWAV = false;
	public boolean supportsAMR = false;
	public boolean supportsMP3 = false;
	public boolean supportsMixing = false;
	//default AMR
	String mimeType = "audio/amr";
	String fileExt = ".amr";

	public SoundManager() {
		initialize();
		loadSounds();
	}
	
	public static SoundManager getInstance() {
		if(instance == null) {
			instance = new SoundManager();
		}
		return instance;
	}
	
	public void initialize() {
	}
	
	public void loadSounds() {
		sound = new MediaPlayer[MAX_SFX];
		for(int i = 0; i < sound.length; i++) {
			System.out.println("Loading sound " + sfxFilename[i]);
            sound[i] = MediaPlayer.create(MainActivity.getInstance(), sfxId[i]);
		}
	}

	public void playBGM(int index) {
		//if(!supportsMixing) return;
		if(!musicEnabled) return;
		stopBGM();
		System.out.println("Loading music " + bgmFilename[index]);
        bgm = MediaPlayer.create(MainActivity.getInstance(), bgmId[index]);
        if(bgm != null) {
        	try {
                bgm.setLooping(true);
                bgm.start();
        	} catch(IllegalStateException ise) {
        		
        	}
        }
	}

	public void stopBGM() {
		if(bgm != null) {
			try {
				bgm.stop();
				bgm.release();
				bgm = null;
			} catch(IllegalStateException ise) {
				
			}
		}
	}
	
	public void pauseBGM() {
		if(bgm != null) {
			try {
				bgm.stop();
			} catch(IllegalStateException ise) {
				
			}
		}
	}
	
	public void resumeBGM() {
		if(bgm != null) {
			try {
				bgm.start();
			} catch(IllegalStateException ise) {
				
			}
		}
	}
	
	public void playSFX(int index)
	{
		if(!soundEnabled) return;
		toPlay = index;
		sound[toPlay].seekTo(0);
		sound[toPlay].start();
	}

	public void stop() {
		stop(false);
	}
	
	public void stop(boolean release) {
		for(int i = 0; i < sound.length; i++)
			if(sound[i] != null) {
				sound[i].stop();
				if(release) {
					sound[i].release();
					sound[i] = null;
				}
			}
	}

}
